"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .benefitdownloadablesproperties import (
    BenefitDownloadablesProperties,
    BenefitDownloadablesPropertiesTypedDict,
)
from datetime import datetime
from polar_sdk.types import BaseModel, Nullable, UNSET_SENTINEL
from polar_sdk.utils import validate_const
import pydantic
from pydantic import model_serializer
from pydantic.functional_validators import AfterValidator
from typing import Dict, Literal, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


BenefitDownloadablesMetadataTypedDict = TypeAliasType(
    "BenefitDownloadablesMetadataTypedDict", Union[str, int, float, bool]
)


BenefitDownloadablesMetadata = TypeAliasType(
    "BenefitDownloadablesMetadata", Union[str, int, float, bool]
)


class BenefitDownloadablesTypedDict(TypedDict):
    id: str
    r"""The ID of the benefit."""
    created_at: datetime
    r"""Creation timestamp of the object."""
    modified_at: Nullable[datetime]
    r"""Last modification timestamp of the object."""
    description: str
    r"""The description of the benefit."""
    selectable: bool
    r"""Whether the benefit is selectable when creating a product."""
    deletable: bool
    r"""Whether the benefit is deletable."""
    organization_id: str
    r"""The ID of the organization owning the benefit."""
    metadata: Dict[str, BenefitDownloadablesMetadataTypedDict]
    properties: BenefitDownloadablesPropertiesTypedDict
    type: Literal["downloadables"]


class BenefitDownloadables(BaseModel):
    id: str
    r"""The ID of the benefit."""

    created_at: datetime
    r"""Creation timestamp of the object."""

    modified_at: Nullable[datetime]
    r"""Last modification timestamp of the object."""

    description: str
    r"""The description of the benefit."""

    selectable: bool
    r"""Whether the benefit is selectable when creating a product."""

    deletable: bool
    r"""Whether the benefit is deletable."""

    organization_id: str
    r"""The ID of the organization owning the benefit."""

    metadata: Dict[str, BenefitDownloadablesMetadata]

    properties: BenefitDownloadablesProperties

    TYPE: Annotated[
        Annotated[
            Literal["downloadables"], AfterValidator(validate_const("downloadables"))
        ],
        pydantic.Field(alias="type"),
    ] = "downloadables"

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["modified_at"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
